/// <reference types="bluebird" />
/// <reference types="sequelize" />
import * as Bluebird from 'bluebird';
import * as Sequelize from 'sequelize';
import { Query, MutateRequest } from 'pretur.sync';
import { ResolveResult } from './resolver';
import { ModelDescriptor } from './descriptor';
import { ResultItemAppender } from './synchronizer';
export interface ModelDescriptorMap {
    [model: string]: ModelDescriptor<any>;
}
export interface Pool {
    models: ModelDescriptorMap;
    resolve<T>(query: Query<T>, context: any): Bluebird<ResolveResult<T>>;
    sync<T>(transaction: Sequelize.Transaction, item: MutateRequest<T>, rip: ResultItemAppender, context: any): Bluebird<Partial<T> | void>;
}
export declare function createPool(...descriptors: ModelDescriptor<any>[]): Pool;
