/// <reference types="sequelize" />
import * as Sequelize from 'sequelize';
import { Pool } from './pool';
import { Spec } from 'pretur.spec';
export declare type SequelizeInstance<T> = Sequelize.Instance<Partial<T>> & Partial<T>;
export declare type SequelizeModel<T> = Sequelize.Model<SequelizeInstance<T>, Partial<T>>;
export interface UninitializedSequelizeModel<T> {
    sequelizeModel: SequelizeModel<T>;
    initialize(pool: Pool): void;
}
export interface BuildSequelizeModelOptions<T> {
    attributeToFieldMap?: {
        [P in keyof T]?: string;
    };
    tableName?: string;
    createDatabase?(sequelizeModel: SequelizeModel<T>): void;
}
export declare function buildSequelizeModel<T extends object>(spec: Spec<T>, sequelize: Sequelize.Sequelize, options?: BuildSequelizeModelOptions<T>): UninitializedSequelizeModel<T>;
